package com.me.brickbuster.entity;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.me.brickbuster.BrickBuster;

public class Paddle extends Entity {

	public static final Color PADDLE_COLOR = Color.BLACK;
	public static final int PADDLE_WIDTH = 100;
	public static final int PADDLE_HEIGHT = 16;
	public static final int PADDLE_Y = 25;
	public static final int PADDLE_SPEED = 10;

	public Paddle(BrickBuster brickBuster) {
		super(brickBuster, BrickBuster.WIDTH/2, PADDLE_Y);
	}

	@Override
	public void render() {
		getShapeRenderer().begin(ShapeRenderer.ShapeType.Filled);
		getShapeRenderer().setColor(PADDLE_COLOR);
		getShapeRenderer().rect(getX() - (PADDLE_WIDTH/2), getY() - (PADDLE_HEIGHT/2), PADDLE_WIDTH, PADDLE_HEIGHT);
		getShapeRenderer().end();
	}

	@Override
	public void update(float dt) {
		Ball ball = getBrickBuster().getBall();
		if (Gdx.input.isKeyPressed(Input.Keys.LEFT)) {
			if (getX() - PADDLE_SPEED - PADDLE_WIDTH/2 < 0) {
				return;
			}
			setX(getX() - PADDLE_SPEED);
			if (!getBrickBuster().isPlaying()) {
				ball.setX(ball.getX() - PADDLE_SPEED);
			}
		}
		if (Gdx.input.isKeyPressed(Input.Keys.RIGHT)) {
			if (getX() + PADDLE_SPEED + PADDLE_WIDTH/2 > BrickBuster.WIDTH) {
				return;
			}
			setX(getX() + PADDLE_SPEED);
			if (!getBrickBuster().isPlaying()) {
				ball.setX(ball.getX() + PADDLE_SPEED);
			}
		}
	}

}
